/**
 * Default Constructor
 */
function TuigwaaUtils(){ 
}

TuigwaaUtils.innerHTML = function(id, html){
  var elem = document.getElementById(id);
  elem.innerHTML = html;
};

TuigwaaUtils.addRow = function(id, data){
  var rowSet = document.getElementById(id);
  var tr  = document.createElement("tr");
  TuigwaaUtils.bindData(tr, data);
  rowSet.appendChild(tr);  
};

TuigwaaUtils.replaceRow = function(id, index, data){
  var rowSet = document.getElementById(id);
  var tr  = document.createElement("tr");
  TuigwaaUtils.bindData(tr, data);
  rowSet.replaceChild(tr, rowSet.childNodes[index]);  
};

TuigwaaUtils.bindData = function(tr, data){
  for(var i=0; i<data.length; i++){
      var td = document.createElement("td");
      td.innerHTML = data[i];
      tr.appendChild(td);
  }
};

TuigwaaUtils.visitChildNodes  = function(elem, func){
  func(elem);
  if(elem.hasChildNodes()){
    for(var i=0; i<elem.childNodes.length; i++){
      TuigwaaUtils.visitChildNodes(elem.childNodes[i], func);
    }
  }     
};

TuigwaaUtils.removeRow = function(id, index){
  var elem = document.getElementById(id);
  elem.removeChild(elem.childNodes[index]);
};

TuigwaaUtils.removeAllChildNodes = function(elem){
  while(elem.hasChildNodes()){
    elem.removeChild(elem.firstChild);
  }
};

TuigwaaUtils.removeAllChildNodesById = function(id){
  var elem = document.getElementById(id);
  TuigwaaUtils.removeAllChildNodes(elem);
};


//[Start] ----- Struts Util -----


TuigwaaUtils.decrementStrutsIndex = function(elem){
   if(typeof(elem.name) == 'string'){
      var result = new String(elem.name.match(/\[([0-9]+)\]\./)).match(/[0-9]+/);;
      var replaceStr = '[' + (--result) + '].';
      elem.name = elem.name.replace(/\[[0-9]+\]\./, replaceStr);  
   }
};


TuigwaaUtils.removeStrutsIndex = function(id, index){
  var rowSet = document.getElementById(id);
  if(rowSet.hasChildNodes()){
      for(var i=index; i<rowSet.childNodes.length; i++){
	TuigwaaUtils.visitChildNodes(rowSet.childNodes[i], TuigwaaUtils.decrementStrutsIndex);
      }
  }
};

TuigwaaUtils.rowIndex = function(trElem){
  var index;

  var rowSetElem = document.getElementById("rowSet");
  
  for(var i=0;i<rowSetElem.childNodes.length;i++){
    if(rowSetElem.childNodes[i]==trElem){
      index = i;
    }
  }
  return index;
};

//[End] ----- Struts Util -----

//[Start] ----- Callback Method -----


TuigwaaUtils.callbackReplaceRow = function(result, exception){
  if(exception) { 
    alert(exception.message); 
  }else{
    eval("var obj =" + result);
    TuigwaaUtils.replaceRow("rowSet", obj.index, obj.data);
  }
};

TuigwaaUtils.updateCounter = function(){
    var rowSetSize = document.getElementById("rowSetSize");
    if(rowSetSize != null){
      TuigwaaUtils.innerHTML("rowSetSize", document.getElementById("rowSet").childNodes.length);
    }
};

    
//[End] ----- Callback Method -----


//[Start] ----- Tuigwaa Utilities -----

// Need Refactoring Here

var form;

function clickAdd()
{
  ajaxRowSet.addRow();
}

function clickRemove(selection)
{
  ajaxRowSet.removeRow(selection);
}

function onChangeType(selection)
{
  var trElem = selection.parentNode.parentNode;
  var rowIndex = TuigwaaUtils.rowIndex(trElem);
  var result = form.replaceRowByAjax(TuigwaaUtils.callbackReplaceRow,rowIndex,selection.value);
}


//[Start] ----- For Entity Form ------

function checkIsEntity(name)
{
  var result = form.checkIsEntityByAjax(callbackCheckIsEntity, name);
}

function callbackCheckIsEntity(result, exception) {
  if(exception) { 
    alert(exception.message); 
  }else{
    var span = document.getElementById("tbl_name_msg");
    if(result==""){
      span.innerHTML = "";
    }else{
      span.innerHTML = result;
    }
  }
}

function addStringArray(index, colIndex, defaultInputSize){
  var rowSetElem = document.getElementById("rowSet");
  var cell = rowSetElem.childNodes[index].childNodes[colIndex];
  var divElem = cell.getElementsByTagName("div")[0];

  var inputSize = divElem.getElementsByTagName("input").length;
 
  var spanElem = document.createElement("span");
  var inputElem = document.createElement("input");
  var brElem = document.createElement("br");
  inputElem.type = "text";
  inputElem.size = "20";
 
  inputElem.setAttribute("name" , "row[" + index + "].list");
  inputElem.setAttribute("maxlength", "100");

  inputElem.onclick = "hoge";

  spanElem.innerHTML = (inputSize+1) + ".";

  spanElem.appendChild(inputElem);
  spanElem.appendChild(brElem);
  divElem.appendChild(spanElem);
}

function removeStringArray(index, colIndex){
  var rowSetElem = document.getElementById("rowSet");
  var cell = rowSetElem.childNodes[index].childNodes[colIndex];
  var divElem = cell.getElementsByTagName("div")[0];
  divElem.removeChild(divElem.lastChild);
}

function booleanAttribute(index, colIndex, isCheckType){
  var rowSetElem = document.getElementById("rowSet");
  var row = rowSetElem.childNodes[index];
  var checkElem = row.childNodes[colIndex-1]
    .getElementsByTagName("input")[0];
  var textElem = row.childNodes[colIndex]
    .getElementsByTagName("input")[3];
    
  if(isCheckType){
    checkElem.checked = false;
    checkElem.disabled = true;
    textElem.value = "";
    textElem.disabled = true;
  }else{
    checkElem.disabled = false;
    textElem.disabled = false;
  }
}


//[End] ----- For Entity Form ------


//[Start] ----- For Data Filter Form ------

function onChangeRestriction(selection)
{
  var trElem = selection.parentNode.parentNode;
  var rowIndex = TuigwaaUtils.rowIndex(trElem);
  var result = form.replaceCellByAjax(callbackReplaceCell,rowIndex, 2, selection.value);
}


function callbackReplaceCell(result, exception){
  if(exception) { 
    alert(exception.message); 
  }else{
    eval("var obj =" + result);
    var rowSet = document.getElementById("rowSet");
    var td = document.createElement("td");
    td.innerHTML = obj.data;
    var dataRow = rowSet.childNodes[obj.rowIndex];
    dataRow.replaceChild(td, dataRow.childNodes[obj.columnIndex]);
  }
}

//[End] ----- For Data Filter Form ------

var AjaxRowSet = Class.create();
AjaxRowSet.prototype = {
 
  initialize: function(rowSetId){
	this.name = '';
	this.basePath = '';
	if(rowSetId == undefined){
		this.rowSetId = 'rowSet';
	}else{
		this.rowSetId = rowSetId;
	}
	this.callbackInit = null;
	this.callbackAdd = null;
	this.callbackRemove = null;
	this.callbackReplace = null;
  },
	
  load: function(){
	  var jsonrpc = new JSONRpcClient(this.basePath);
	  eval("form = jsonrpc." + this.name); 
	  TuigwaaUtils.removeAllChildNodesById(this.rowSetId);
	  var result = form.initializeByAjax(this.onLoad.bind(this));
  },
    
  onLoad: function(result, exception){
	if(exception) {  
		alert(exception.message); 
	}else{
    	for(var i=0; i<result.length; i++){
	      TuigwaaUtils.addRow(this.rowSetId, result[i]);
    	}
	    TuigwaaUtils.updateCounter();
	    if(this.callbackInit != null){
    		this.callbackInit();
    	}
    }
  },

  addRow: function(){
	  form.addRowByAjax(this.onRowAdd.bind(this));
  },
  
  removeRow: function(selection){
      var trElem = selection.parentNode.parentNode;
 	  var rowIndex = TuigwaaUtils.rowIndex(trElem);
	  var result = form.removeRowByAjax(this.onRowRemove.bind(this),rowIndex);
  },
  
  onRowAdd: function(result, exception){
	 if(exception) { 
    	alert(exception.message); 
	 }else{
	    TuigwaaUtils.addRow(this.rowSetId, result);
   		TuigwaaUtils.updateCounter();
   	    if(this.callbackAdd != null){
          this.callbackAdd();
        }
     }
  }, 

  onRowRemove: function(result, exception){
	  if(exception) { 
    	alert(exception.message); 
	  }else{
    	TuigwaaUtils.removeRow(this.rowSetId, result);
	    TuigwaaUtils.removeStrutsIndex(this.rowSetId, result);
	    TuigwaaUtils.updateCounter();
   	    if(this.callbackRemove != null){
          this.callbackRemove(result);
        }
	  }
  }
}



//[Start] ------ SpreadSheet -------

SpreadSheet = Class.create();
SpreadSheet.prototype = {
  initialize: function(elem) {
	this.elem = $(elem);
	this.rows = new Array();
	this.rowIndex = 0;
	this.cellIndex = 1;
	this.isActivate = false;

	this.addRow = null;

	this.onLoadCallback = this.onLoad.bind(this);
	this.onRowAddCallback = this.onRowAdd.bind(this);
	this.onRowRemoveCallback = this.onRowRemove.bind(this);

	this.tbody = this.elem.getElementsByTagName('tbody')[0];
	
	this.initEvent();
  },

  initEvent: function(){
	  Event.observe(document, "keypress" , this.onKeyPress.bind(this), true);  	
  	  new PeriodicalExecuter(this.checkEvents.bind(this), 10);
  },

  checkEvents: function(){
  	form.checkEventsByAjax(this.onReceiveEvents.bind(this));
  },

  onReceiveEvents: function(result){
	eval('var events =' + result);
	if(events.length){
		for(var i=0;i<events.length;i++){
			var row = this.findRow(events[i].id);
			if(row!=null){
				var colIndex = events[i].col;
				row.cells[colIndex].setValue(events[i].value);
			}
		}
	}
  },

  onLoad: function(){
	var trs = this.tbody.getElementsByTagName('tr');	
	for(var i=0;i<trs.length;i++){
		this.rows.push(new SpreadSheet.Row(trs[i], this));	
	}		
  	this.focusFirstCell();
  },

  onRowAdd: function(){
	var trs = this.tbody.getElementsByTagName('tr');	
	this.rows.push(new SpreadSheet.Row(trs[trs.length-1], this));	
	this.unfocus();
	this.rowIndex++;
	this.cellIndex = 1;
	this.rows.last().focusFirstCell();
  },

  onRowRemove: function(index){
	this.unfocus();
	
	this.tmpRows = new Array();
	var found = 0;
	for(var i=0;i<this.rows.length;i++){
		if(index == i){
			found = 1;
		}else{
			this.tmpRows[i-found] = this.rows[i];
		}
	}


	this.rows = this.tmpRows;		
	this.rowIndex = index;
	if(this.rowIndex >= this.rows.length){ 
		this.rowIndex = this.rows.length -1;
	}
	this.cellIndex = 1;
  	this.focus();
  },

  focusFirstCell: function(){
	this.rows[0].focusFirstCell();
  },

  focus: function(){
   	this.rows[this.rowIndex].cells[this.cellIndex].focus();
  },

  unfocus: function(){
  	this.isActivate = false;
   	this.rows[this.rowIndex].cells[this.cellIndex].unfocus();
  },

  right: function(){
	if(this.cellIndex<this.rows[this.rowIndex].cells.length-2){
		this.unfocus();
		this.cellIndex++;
		this.focus();
	}
  },

  left: function(){
	if(this.cellIndex>1){
		this.unfocus();
		this.cellIndex--;
		this.focus();
	}
  },

  down: function(){
	if(this.rowIndex<this.rows.length-1){
		this.unfocus();
		this.rowIndex++;
		this.focus();
	} 
  },

  up: function(){
	if(this.rowIndex>0){
		this.unfocus();
		this.rowIndex--;
		this.focus();
	}
  },
  
  onActivate: function(row, col){
	if(this.rowIndex!=row||this.cellIndex!=col){
		this.unfocus();
		this.rowIndex = row;
		this.cellIndex = col;
		this.focus();
	}	
	this.isActivate = true;
  },
	
  currentCell: function(){
  	return this.rows[this.rowIndex].cells[this.cellIndex];
  },
  
  activate: function(){
  	this.rows[this.rowIndex].cells[this.cellIndex].activate();
  },
  
  unactivate: function(){
  	this.isActivate = false;
  	this.rows[this.rowIndex].cells[this.cellIndex].unactivate();
  },
  
  onChangeRow: function(row, col, value){
	form.changeCellByAjax(row.id, col, value);
  },

  findRow: function(id){
  	for(var i=0; i<this.rows.length;i++){
  		if(id==this.rows[i].id){
  			return this.rows[i];
  		}
  	}
  	return null;
  },

  onKeyPress: function(event) {
  	switch(event.keyCode){
		case Event.KEY_UP:
			if(!this.isActivate){
				this.up();
				Event.stop(event);
			}
			return;
		case Event.KEY_DOWN:
			if(!this.isActivate){
				this.down();
				Event.stop(event);
			}			
			return;
		case Event.KEY_RIGHT:
			if(!this.isActivate){
				this.right();			
				Event.stop(event);
			}else{
				if(this.currentCell().elementLength()>1){
					this.currentCell().right();
					Event.stop(event);
				}
			}
			return;
		case Event.KEY_LEFT:
			if(!this.isActivate){
				this.left();
				Event.stop(event);
			}else{
				if(this.currentCell().elementLength()>1){
					this.currentCell().left();
					Event.stop(event);
				}
			}		
			return;
		case Event.KEY_RETURN:
			if(this.isActivate){
				this.unactivate();
				if(this.rowIndex < this.rows.length-1){	
					this.down();
				}else{
					this.right();
				}
			}else{
				this.activate();
			}
			Event.stop(event);
			return;
		case Event.KEY_TAB:
			Event.stop(event);
			if(this.cellIndex<this.rows[this.rowIndex].cells.length-2){
				this.right();
			}else if(this.rowIndex < this.rows.length-1){	
				this.unfocus();
				this.rowIndex++;
				this.cellIndex =1;
				this.focus();
			}else{
				if(this.addRow != null){
					this.addRow();
				}
			}
			return;
		default:
			this.activate();
			return;
  	}
  }
}

SpreadSheet.Row = Class.create();
SpreadSheet.Row.prototype = {
  initialize: function(elem, spreadsheet) {
	this.elem = $(elem);
	this.spreadsheet = spreadsheet;
	this.cells = new Array();
	var tds = this.elem.getElementsByTagName('td');
	for(var i=0;i<tds.length;i++){
		if(i==0){
			var inputs = elem.getElementsByTagName('input');
			for(var j=0; j<inputs.length; j++){
				if(inputs[j].getAttribute('type')=="hidden"){
					this.id = inputs[j].getAttribute('value');
					break;
				}
			}
		}
		this.cells.push(new SpreadSheet.Cell(tds[i],this));		
	}
  },

  focusFirstCell: function(){
	this.cells[1].focus();
  },
     
  onChangeCell: function(cell, value){
	var col = this.cells.indexOf(cell);
  	this.spreadsheet.onChangeRow(this, col, value);
  },

  onKeyPress: function(event) {
  }
}

SpreadSheet.Cell = Class.create();
SpreadSheet.Cell.prototype = {
  initialize: function(elem, row) {
	this.elem = $(elem);
  	this.row = row;
  	this.changed = false;
  	this.changePing = false;
  
  	var inputs = this.elem.getElementsByTagName('input');
 	var selects = this.elem.getElementsByTagName('select');

	if(inputs.length > 0){
  		this.formelems = inputs;
  		for(var i=0; i<inputs.length; i++){
  			if(inputs[i].getAttribute('type')=="text"){
  				this.formelem = inputs[i];
  				break;
  			}
  		}
  	}else if(selects.length>0){
  		this.formelems = selects;
  		this.formelem = selects[0];
  	}else{
  		this.formelems = null;
  		this.formelem = null;
  	}

	this.index = 0;

	if(this.formelem!=null){
		for(var i=0;i<this.formelems.length;i++){
			new Form.Element.EventObserver(this.formelems[i], this.onChange.bind(this));
		  	Event.observe(this.formelems[i],'focus',this.onFocus.bind(this));
  			Event.observe(this.formelems[i],'blur',this.onBlur.bind(this));
		}
	  }
  },

  elementLength: function(){
 	if(this.formelems == null){
 		return 0;
 	}
 	return this.formelems.length;
  },

  scroll: function(){
  	var y = Position.cumulativeOffset(this.formelem)[1];
	if(window.innerHeight){ 	 
 	 	var height = window.innerHeight;
	}else{
		var height = document.documentElement.clientHeight;
	}
	var over = y - (height-30);
	if(over>0){
		window.scroll(0,over);
	}
  },

  onFocus: function(){
	this.setBGColor('silver');
	var rowIndex = this.row.spreadsheet.rows.indexOf(this.row);
	var colIndex = this.row.cells.indexOf(this);
  	this.row.spreadsheet.onActivate(rowIndex,colIndex);
  },

  onBlur: function(){
	this.setBGColor('white');
    if(this.changed){
		this.setBGColor('aqua');
	 }
  },

  onChange : function(){
	if(this.changePing){
		this.changePing = false;
	}else{
		this.changed = true;
		this.formelem.style.backgroundColor = 'aqua';
	
		var value = '';
		
		for(var i=0;i<this.formelems.length;i++){
			if(i>0){
				value += ',';
			}
			value += Form.Element.getValue(this.formelems[i]);	
		}
		this.row.onChangeCell(this, value);
	}
  },
  
  focus: function(){
  	this.elem.style.backgroundColor = 'red';
  	this.scroll();
  },

  activate: function(){ 
	this.index = 0;
  	this.formelem.focus();
  },
    
  unactivate: function(){ 
  	this.formelem.blur();
  },
   
  right: function(){
	if(this.index < this.formelems.length - 1){
		this.formelems[this.index].blur();
		this.index ++;
		this.formelems[this.index].focus();
  	}
  }, 
    
  left: function(){
	if(this.index > 0){
		this.index --;
		this.formelems[this.index].focus();
  	}
  }, 
    
  setValue: function(value){
	this.changePing = false;
	
	this.setBGColor('red');
	
	if(this.formelems.length==1){
	  	this.formelem.value = value;
  	}else{
   		var values = value.split(',');
  		for(var i=0;i<this.formelems.length;i++){
  			this.formelems[i].value = values[i];
  		}
  	}
  },
  
  setBGColor: function(color){
	for(var i=0;i<this.formelems.length;i++){
		this.formelems[i].style.backgroundColor = color;
	}
  },
  
  unfocus: function(){
   	this.elem.style.backgroundColor = 'silver';
  }
}
