
function isNewEventType(){
  if(typeof document.implementation != "undefined" &&
	 document.implementation.hasFeature("HTML",   "1.0") &&
         document.implementation.hasFeature("Events", "2.0") &&
         document.implementation.hasFeature("CSS",    "2.0") ){
    return true;
  }else{
    return false;
  }
};

function addEvent(elem,eventType,func,option){
  if(isNewEventType()){
    elem.addEventListener(eventType, func, option);
  }else {
    elem.attachEvent("on" + eventType, func);
  }
};


Dialog = Class.create();
Dialog.prototype = {
 
  initialize: function(url, callback, width, height) {
    this.url = url;
    
    this.callback = callback;
    this.manager = null;
    this.activeWindow = null;
    this.width = width;
    this.height = height;
  },

  setDialogManager: function(manager){
    this.manager = manager;
  },

  bindOnclick: function(id){
    addEvent($(id), "click", this._open.bindAsEventListener(this), false);
  },

  open: function(){
   var option = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes, width=' + this.width + ', height=' + this.height;
   // var option = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
   this.activeWindow = window.open(this.url,"activeWindow",option);
    //   addEvent(this.activeWindow, "load", this.onload.bindAsEventListener2(this, this.activeWindow),  false);
	
  },

  close: function(){
    this.actvieWindow = null;
  },

  focus: function(){
    this.activeWindow.focus();
  },

  _open: function(){
    this.manager.openDialog(this);
  },
  
  _close: function(){
    this.manager.closeDialog(this);
  }
};


DialogManager = Class.create();
DialogManager.prototype = {
  
  initialize: function(){
    this.baseWindow = window;
    this.dialogs = new Array();
    this.activeDialog = null;
  },

  baseWindowUpdate: function(url){
    this.baseWindow.location = url;
  },

  registerDialogWithId: function(id,dialog){
    this.dialogs[this.dialogs.length] = dialog;
    dialog.setDialogManager(this);
    dialog.bindOnclick(id);
  },

  popupWithFunction: function(url, func, width, height){
    var newDialog = new Dialog(url, func,width, height);
    newDialog.setDialogManager(this);
    this.openDialog(newDialog); 
  },
  
  popup: function(url, width, height){
    var newDialog = new Dialog(url, null ,width, height);
    newDialog.setDialogManager(this);
    this.openDialog(newDialog); 
  },
  
  openDialog: function(dialog){
    this.activeDialog = dialog;
    dialog.open();
    dialog.focus();
  },
    
  closeDialog: function(){
    this.activeDialog.close();
    this.activeDialog = null;
    window.focus();
  },

  getActiveDialog: function(){
    return this.activeDialog;
  },

  onfocusWindow: function(e){
    if(this.activeDialog){
      this.activeDialog.focus();
    }
  },
  
  initializeEventHandlers: function(){
    addEvent(window, "focus", this.onfocusWindow.bindAsEventListener(this),  false);
  }
};
  
var dialogMgr = new DialogManager();
dialogMgr.initializeEventHandlers();


var TextSetter = Class.create();

TextSetter.prototype = {

  initialize: function(id) {
	this.textfield = $(id);
	this.setMethod = this.set.bind(this);
  },

  set: function(value){
	this.textfield.value = value;
  }
}

