/**
 *  for DataFilterForm multi sort
 **/
var AttrDraggable = Class.create();

AttrDraggable.removeOnDrop = false;
AttrDraggable.revereNamesOnDrop = true;


AttrDraggable.prototype = (new Rico.Draggable()).extend( {
   initialize: function( htmlElement,displayName, name,asc_str,desc_str,selectedOrder) {
      this.type        = 'Custom';
      this.id = htmlElement;
      this.htmlElement = $(htmlElement);
      this.name      = name;
	  this.selectedOrder = selectedOrder;
      this.insertForms = selectedOrder;
      this.displayName = displayName;
      
      this.radio_asc = "<input type='radio' name='dataFilterFormOrderRow["+name+"].ascendant' value='true' checked/>"+asc_str+"";
      this.radio_desc = "<input type='radio' name='dataFilterFormOrderRow["+name+"].ascendant' value='false' />"+desc_str+"&nbsp;";
      this.hidden_selected = "<input type='hidden' name='dataFilterFormOrderRow["+name+"].orderSelected' value='true' />";
      this.hidden_selectedOrder = "<input type='hidden' name='dataFilterFormOrderRow["+name+"].selectedOrder' value='"+this.name+"' />";
      
      
            

   },
   select: function() {
      this.selected = true;
      var el = this.htmlElement;

      // show the item selected.....
      el.style.color           = "#ffffff";
      el.style.backgroundColor = "#08246b";
      el.style.border          = "1px solid blue";
   },

   deselect: function() {
      this.selected = false;
      var el = this.htmlElement;
      el.style.color           = "#2b2b2b";
      el.style.backgroundColor = "transparent";
      el.style.border = "1px solid #ffffee";
   },

   startDrag: function() {
      var el = this.htmlElement;
   },

   cancelDrag: function() {
      var el = this.htmlElement;
   },

   endDrag: function() {
     
      var el = this.htmlElement;
      if ( AttrDraggable.removeOnDrop )
         this.htmlElement.style.display = 'none';

   },

   getSingleObjectDragGUI: function() {
      var el = this.htmlElement;

      var div = document.createElement("div");
      div.className = 'customDraggable';
      div.style.width = (this.htmlElement.offsetWidth - 10) + "px";
      new Insertion.Top( div, this.displayName );
      return div;
   },

   getMultiObjectDragGUI: function( draggables ) {
      var el = this.htmlElement;

      var names = "";
      for ( var i = 0 ; i < draggables.length ; i++ ) {
         names += draggables[i].displayName;
         if ( i != (draggables.length - 1) )
            names += ",<br/>";
      }

      var div = document.createElement("div");
      div.className = 'customDraggable';
      div.style.width = (this.htmlElement.offsetWidth - 10) + "px";
      new Insertion.Top( div, names );
      return div;
   },
   getDroppedGUI: function() {
      
      var div = document.getElementById(this.id);
      
      if(this.selectedOrder && this.insertForms == false){
        new Insertion.Top(div,"<span id='span"+this.id+"'>" + this.radio_asc+this.radio_desc+this.hidden_selected+this.hidden_selectedOrder+" </span>");
        var el = this.htmlElement;
        this.insertForms = true;
      }else if(this.selectedOrder == false && this.insertForms == true){
        var rem = document.getElementById('span'+this.id);
        div.removeChild(rem);
        this.insertForms = false;
      }
      return div;
   },
   toString: function() {
      return this.name;
   }

} );

var NoSortDropzone = Class.create();

NoSortDropzone.prototype = (new Rico.Dropzone()).extend( {
   accept: function(draggableObjects) {
      var htmlElement = this.getHTMLElement();
      if ( htmlElement == null )
         return;

      n = draggableObjects.length;
      for ( var i = 0 ; i < n ; i++ )
      {
         draggableObjects[i].selectedOrder = false;
         var theGUI = draggableObjects[i].getDroppedGUI();
         if ( RicoUtil.getElementsComputedStyle( theGUI, "position" ) == "absolute" )
         {
            theGUI.style.position = "static";
            theGUI.style.top = "";
            theGUI.style.top = "";
         }
         htmlElement.appendChild(theGUI);
      }
   }

} );


var SortDropzone = Class.create();

SortDropzone.prototype = (new Rico.Dropzone()).extend( {
   accept: function(draggableObjects) {

      var htmlElement = this.getHTMLElement();
      if ( htmlElement == null )
         return;

      n = draggableObjects.length;
      for ( var i = 0 ; i < n ; i++ )
      {
         draggableObjects[i].selectedOrder = true;
         var theGUI = draggableObjects[i].getDroppedGUI();
         
         if ( RicoUtil.getElementsComputedStyle( theGUI, "position" ) == "absolute" )
         {
            theGUI.style.position = "static";
            theGUI.style.top = "";
            theGUI.style.top = "";
         }
         htmlElement.appendChild(theGUI);
      }
      

      var divCount = 0;

      var formNames = new Array(4);
      formNames[0] = "ascendant";
	  formNames[1] = "ascendant";
	  formNames[2] = "orderSelected";
      formNames[3] = "selectedOrder";

      var childs = htmlElement.childNodes;      
      for(i = 0; i<childs.length ; i++){
        var aDiv = childs.item(i);

        if(aDiv.nodeType == 1 && aDiv.id.indexOf('id_',0) > -1){
            // aDiv is div node.
            var spans = aDiv.childNodes;
            for(j=0;j<spans.length;j++){

              var aSpan = spans.item(j);	

              if(aSpan.nodeType == 1 && aSpan.id.indexOf('spanid_',0) > -1){
                var attributeCount = 0;
                var formAttributes = aSpan.childNodes;

                for(k=0;k<formAttributes.length;k++){
                  var aAttribute = formAttributes.item(k);
                  if(aAttribute.nodeType == 1 && aAttribute.name.indexOf('dataFilterFormOrderRow',0) > -1){
                    aAttribute.setAttribute('name','dataFilterFormOrderRow['+divCount+'].'+formNames[attributeCount]);
                    attributeCount++;
                  }
                }
              }
              
            }
            divCount++;
        }
      }
   }

} );



