
var TuigwaaDomUtils = {

	removeAllChildNodes : function(elem){
		while(elem.hasChildNodes()){
   			 elem.removeChild(elem.firstChild);
		}	
	}
}


var TuigwaaTemplate = {
	
	VERSION : "0.1",
	URL : "http://127.0.0.1:8080/tuigwaa/meibo",
	
	parse : function(){
		this.parseTable();
		this.parseForm();
		this.parseRecord();
	},

	parseTable : function(){
		var divTable = document.getElementById("tgw.table");
		if(divTable == null){
			return;
		}
		
		var entityName = divTable.getAttribute("class");
		
		this.sendRequest(this.URL + "/jsTable.do?entityName=" + entityName);
		
		
//		this.mergeTable({
//			entity : "person",
//			datatable : [
//				{id:2, name:"nishioka"},
//				{id:3, name:"someda"}
//			]
//		});
	},

	parseRecord : function(){
		var query = window.location.search;
		if(query == null || query == ''){
			return;
		}		
		query = query.substring(1,query.length);
		var params = query.split("&");
		for(i in params){
			 if(params[i].match(/tgw\.data\.(\w+)=([0-9]+)/)){
				var entity = RegExp.$1;
				var id = RegExp.$2;

				this.sendRequest(this.URL + "/jsData.do?entityName=" + entity + "&id=" + id);

				//alert(id);
				//this.mergeData({
				//	entity : "person",
				//	data : {
				//		name : "hogehoge"
				//	}
				//});
				
			 }			
		}	
	},

	parseForm : function(){
		var divForm = document.getElementById("tgw.form");
		if(divForm == null){
			return;
		}
		var entityName = divForm.getAttribute("class");
		var form = divForm.getElementsByTagName("form")[0];
		
		this.sendRequest(this.URL + "/jsForm.do?entityName=" + entityName);
	
		//	this.mergeForm({
		//	action : "http://127.0.0.1:8080/tuigwaa/meibo/_saveperson.do",
		//	entityName : "person",
		//	attrNames : {
		//		name : "__name__"
		//	}
		//});
	},

	mergeData : function(dataInfo){
		var dataId = "tgw.data." + dataInfo.entity;
		var span = document.getElementById(dataId);
//		var span = document.getElementById("tgw");
		var attr = span.getAttribute("class");
		span.innerHTML = dataInfo.data[attr];
	},
	
	mergeTable : function(tableInfo){
		var divTable = document.getElementById("tgw.table");
		var tbody = divTable.getElementsByTagName("table")[0].getElementsByTagName("tbody")[0];
		var trTemplate = tbody.getElementsByTagName("tr")[0];
		
		TuigwaaDomUtils.removeAllChildNodes(tbody);

//		var tds = tbody.getElementsByTagName("tr")[0].getElementsByTagName("td");
	
		var datatable = tableInfo.datatable;	
		for(var i in datatable){
			var tr = trTemplate.cloneNode(true);
			this.mergeRow(tr, tableInfo.entity ,datatable[i]);
			tbody.appendChild(tr);
		}
	},

	mergeRow : function(tr, entityName, data){
		var span = tr.getElementsByTagName("span");
		for(var i=0; i<span.length; i++){
			var clazz = span[i].getAttribute("class");		
			if(clazz == null){
				continue;
			}
			var attrs = clazz.split(".");
			if(attrs.length > 2 && attrs[0] == "tgw" && attrs[1] == "row"){
				span[i].innerHTML = data[attrs[2]];	
			}
		}

		var a = tr.getElementsByTagName("a");
		for(var i = 0; i<a.length; i++){
			var href = a[i].getAttribute("href");
			href = href + "?tgw.data." + entityName + "=" + data.id;
			a[i].setAttribute("href" , href);
		}
	},
	
	mergeForm : function(formInfo){
		var divForm = document.getElementById("tgw.form");
		var entityName = divForm.getAttribute("class");
		var form = divForm.getElementsByTagName("form")[0];
		var redirectURL = form.getAttribute("action");
		
	    var inputs = form.getElementsByTagName('input');
	    for (var i = 0; i < inputs.length; i++) {
    	  var input = inputs[i];
    	  var attrName = formInfo.attrNames[input.name];
		  if(attrName != undefined){
		  	input.name = attrName;
		  }
	    } 	
		
		this.appendHiddenElement(form, "tgw.redirectURL", redirectURL);
		this.appendHiddenElement(form, "tableName", formInfo.entityName);
	
		form.setAttribute("action", formInfo.action);
	},
	
	appendHiddenElement : function(form, name, value){
		var hiddenElem = document.createElement("input");
		hiddenElem.setAttribute("type", "hidden");
		hiddenElem.setAttribute("name", name);
		hiddenElem.setAttribute("value", value);	
		form.appendChild(hiddenElem);		
	},

	sendRequest : function(url){
		var script = document.createElement("script");
		script.setAttribute("src", url);
		document.body.appendChild(script);
	}

}

function tuigwaaparse(){
	TuigwaaTemplate.parse();
}

if (window.addEventListener) {
	window.addEventListener("load", tuigwaaparse, true);
} else if (window.attachEvent) {
	window.attachEvent("onload", TuigwaaTemplate.parse);
}

//document.onload = TuigwaaTemplate.parse;